from bitcoding import B_dict
from basesplit import bsplit
from baserels import B
from glob import globs  
from functools import reduce

N = globs["size"]
DALL = B_dict['DALL']

def start(i, fcomp):
   relations, composition = i.split('::')
   relA, relB = relations.strip().split(':')
   composition = composition.replace(')','').replace('(','').strip().split()
   fcomp[B_dict[relA.strip()]-1][B_dict[relB.strip()]-1] = reduce(lambda x, y: x | y, [B_dict[i] for i in composition])

def complete(fcomp):
   for i in range((2**N)-1):
      for j in range((2**N)-1):
         comp = 0 
   
         for m in bsplit[i][1]:
            for n in bsplit[j][1]:
               comp |= fcomp[m-1][n-1]
               if comp == DALL: 
                  break # stop calculating if the global relation
            else:
               continue  # executed if the loop ended normally (no break)
            break  # executed if 'continue' was skipped (break)
           
         fcomp[i][j] = comp

# initialize matrix to hold compositions between all 256 possible relations
with open(globs['calc']+"/"+globs['calc']+".comp") as f:

   from array import array
   if N <= 8:
      fcomp = [array('B',[0 for i in range((2**N)-1)]) for j in range((2**N)-1)]
   elif N <= 16:
      fcomp = [array('H',[0 for i in range((2**N)-1)]) for j in range((2**N)-1)]
   else:
      fcomp = [array('I',[0 for i in range((2**N)-1)]) for j in range((2**N)-1)]
  
   for i in f:
      start(i,fcomp)

   complete(fcomp)



